# Contributing to `data-science-curriculum`

Thanks for your interest in contributing! Please follow the guidelines below, and contact one of the Maintainers (listed below) if you have any questions.

## Reporting an issue

If you find a issue with the lessons, please file a [new
issue](https://github.com/zdelrosario/data-science-curriculum/issues). Please
include a [reproducible
example](https://stackoverflow.com/help/minimal-reproducible-example) in your
issue.

## Contributing to the curriculum

We welcome contributions to `data-science-curriculum`! To contribute, please
determine what sort of contribution you plan to make. For more detailed
information on forking and branching in the context of contributing, please see
[this guide](https://opensource.com/article/19/7/create-pull-request-github).

### Bug-fix

If you find an issue with the software or want to fix an existing issue, please follow these steps:

1. If one does not yet exist, please report an Issue following the instructions in **Reporting an issue** above.
2. Fork `data-science-curriculum` and clone a local copy of the repository for your work.
3. Create a branch for your fix with the name `fix_name`, where `name` should be sensibly related to your fix.
4. Implement your fix.
5. Create a pull request against `data-science-curriculum` on the `develop` branch; one of the Maintainers will review your contribution.

### New Lessons

If you wish to add a new lesson to `data-science-curriculum`, please follow these steps:

1. Fork `data-science-curriculum` and clone a local copy of the repository for your work.
2. Create a branch for your fix with the name `dev_name`, where `name` should be sensibly related to your lesson.
3. Implement your feature.
4. Create a pull request against `data-science-curriculum` on the `develop` branch; one of the Maintainers will review your contribution.

Your lesson should conform to the lesson styleguide, which I will definitely write soon....

## List of Maintainers

Updated 2020-06-09

- Zachary del Rosario (zdelrosario(at)outlook(doot)com)

### Becoming a maintainer

If you'd like to become a maintainer, you must first create (at least) one new
lesson and have it approved by a current maintainer. Then reach out to the
maintenance team directly to ask about becoming a maintainer.
